C=======================================================================
      MODULE      HE_DEN
      COMPLEX     DE_RHO,DE_TAU,DE_LPR,DE_DIV,
     *            DE_SPI,DE_KIS,DE_GRR,DE_LPS,DE_ROS,DE_ROC,DE_CUR,
     *            DE_SCU,DE_DES
      ALLOCATABLE DE_RHO(:,:,:,:),DE_TAU(:,:,:,:),
     *            DE_LPR(:,:,:,:),DE_DIV(:,:,:,:)
      ALLOCATABLE DE_SPI(:,:,:,:,:),DE_KIS(:,:,:,:,:),
     *            DE_GRR(:,:,:,:,:),DE_LPS(:,:,:,:,:),
     *            DE_ROS(:,:,:,:,:),DE_ROC(:,:,:,:,:),
     *            DE_CUR(:,:,:,:,:)
      ALLOCATABLE DE_SCU(:,:,:,:,:,:),DE_DES(:,:,:,:,:,:)
      END MODULE  HE_DEN
C=======================================================================
      MODULE      PD_DEN
      COMPLEX     PD_RHO,PP_RHO
      ALLOCATABLE PD_RHO(:,:,:,:),PP_RHO(:,:,:,:)
      END MODULE  PD_DEN
C=======================================================================
      MODULE      VE_FLD
      COMPLEX     VE_MAS,VE_CEN,VE_KIS,VE_SPI,VE_CUR,VE_SOR
      ALLOCATABLE VE_MAS(:,:,:,:),VE_CEN(:,:,:,:),
     *            VE_KIS(:,:,:,:,:),VE_SPI(:,:,:,:,:),
     *            VE_CUR(:,:,:,:,:),
     *            VE_SOR(:,:,:,:,:,:)
      END MODULE  VE_FLD
C=======================================================================
      MODULE      WD_FLD
      COMPLEX     WD_CEN
      ALLOCATABLE WD_CEN(:,:,:,:)
      END MODULE  WD_FLD
C=======================================================================
      MODULE      BROYIN
      SAVE        BRO_IN
      ALLOCATABLE BRO_IN(:)
      END MODULE  BROYIN
C=======================================================================
      MODULE      BROYOU
      SAVE        BRO_OU
      ALLOCATABLE BRO_OU(:)
      END MODULE  BROYOU
C=======================================================================
      MODULE      BROYIN_NEUTRON
      SAVE        BRONIN
      ALLOCATABLE BRONIN(:)
      END MODULE  BROYIN_NEUTRON
      MODULE      BROYOU_NEUTRON
      SAVE        BRONOU
      ALLOCATABLE BRONOU(:)
      END MODULE  BROYOU_NEUTRON
C=======================================================================
      MODULE      BROYIN_PROTON
      SAVE        BROPIN
      ALLOCATABLE BROPIN(:)
      END MODULE  BROYIN_PROTON
      MODULE      BROYOU_PROTON
      SAVE        BROPOU
      ALLOCATABLE BROPOU(:)
      END MODULE  BROYOU_PROTON
C=======================================================================
      MODULE      MAT_PP
      SAVE        BIG_PP
      COMPLEX     BIG_PP
      ALLOCATABLE BIG_PP(:,:,:)
      END MODULE  MAT_PP
C=======================================================================
      MODULE      MAT_PM
      SAVE        BIG_PM
      COMPLEX     BIG_PM
      ALLOCATABLE BIG_PM(:,:,:)
      END MODULE  MAT_PM
C=======================================================================
      MODULE      KAP_PP
      SAVE        PAI_PP
      COMPLEX     PAI_PP
      ALLOCATABLE PAI_PP(:,:,:)
      END MODULE  KAP_PP
C=======================================================================
      MODULE      KAP_PM
      SAVE        PAI_PM
      COMPLEX     PAI_PM
      ALLOCATABLE PAI_PM(:,:,:)
      END MODULE  KAP_PM
C=======================================================================
      MODULE      MAD_PP
      SAVE        DEN_PP
      COMPLEX     DEN_PP
      ALLOCATABLE DEN_PP(:,:,:,:)
      END MODULE  MAD_PP
C=======================================================================
      MODULE      MAD_PM
      SAVE        DEN_PM
      COMPLEX     DEN_PM
      ALLOCATABLE DEN_PM(:,:,:,:)
      END MODULE  MAD_PM
C=======================================================================
      MODULE      MAP_PM
      SAVE        CHI_PM
      COMPLEX     CHI_PM
      ALLOCATABLE CHI_PM(:,:,:,:)
      END MODULE  MAP_PM
C=======================================================================
      MODULE      MAF_PP
      SAVE        FIL_PP
      COMPLEX     FIL_PP
      ALLOCATABLE FIL_PP(:,:,:,:)
      END MODULE  MAF_PP
C=======================================================================
      MODULE      MAF_PM
      SAVE        FIL_PM
      COMPLEX     FIL_PM
      ALLOCATABLE FIL_PM(:,:,:,:)
      END MODULE  MAF_PM
C=======================================================================
      MODULE      MAP_PP
      SAVE        FIP_PP
      COMPLEX     FIP_PP
      ALLOCATABLE FIP_PP(:,:,:,:)
      END MODULE  MAP_PP
C=======================================================================
      MODULE      HCOULO
      SAVE        HPPCOU
      SAVE        HPMCOU
      COMPLEX     HPPCOU
      COMPLEX     HPMCOU
      ALLOCATABLE HPPCOU(:,:)
      ALLOCATABLE HPMCOU(:,:)
      END MODULE  HCOULO
C=======================================================================
      MODULE      HYUKAW
      SAVE        HPPYUK
      SAVE        HPMYUK
      COMPLEX     HPPYUK
      COMPLEX     HPMYUK
      ALLOCATABLE HPPYUK(:,:,:)
      ALLOCATABLE HPMYUK(:,:,:)
      END MODULE  HYUKAW
C=======================================================================
      MODULE      PAIDEL
      SAVE        HAMIDE
      COMPLEX     HAMIDE
      ALLOCATABLE HAMIDE(:,:,:)
      END MODULE  PAIDEL
C=======================================================================
      MODULE      SPINOR
      SAVE        WSWAVE
      COMPLEX     WSWAVE
      ALLOCATABLE WSWAVE(:,:,:)
      END MODULE  SPINOR
C=======================================================================
      MODULE      WAVSQU
      SAVE        SQUWAV
      ALLOCATABLE SQUWAV(:,:,:,:)
      END MODULE  WAVSQU
C=======================================================================
      MODULE      WAVR_L
      SAVE        WARIGH
      SAVE        WALEFT
      COMPLEX     WARIGH
      COMPLEX     WALEFT
      ALLOCATABLE WARIGH(:,:,:)
      ALLOCATABLE WALEFT(:,:,:)
      END MODULE  WAVR_L
C=======================================================================
      MODULE      SAVRIG
      SAVE        SARIGH
      COMPLEX     SARIGH
      ALLOCATABLE SARIGH(:,:,:,:)
      END MODULE  SAVRIG
C=======================================================================
      MODULE      SAVLEF
      SAVE        SALEFT
      COMPLEX     SALEFT
      ALLOCATABLE SALEFT(:,:,:,:)
      END MODULE  SAVLEF
C=======================================================================
      MODULE      ALLWAV
      SAVE        WAVOCC
      COMPLEX     WAVOCC
      ALLOCATABLE WAVOCC(:,:,:)
      END MODULE  ALLWAV
C=======================================================================
      MODULE      ALLSIZ
      SAVE        EWASIZ
      COMPLEX     EWASIZ
      ALLOCATABLE EWASIZ(:,:)
      END MODULE  ALLSIZ
C=======================================================================
      MODULE      SAVQUA
      SAVE        ASVQUA         ,BSVQUA
      COMPLEX     ASVQUA         ,BSVQUA
      ALLOCATABLE ASVQUA(:,:,:,:),BSVQUA(:,:,:,:)
      END MODULE  SAVQUA
C
      MODULE      ALLQUA
      SAVE        AWAQUA       ,BWAQUA
      COMPLEX     AWAQUA       ,BWAQUA
      ALLOCATABLE AWAQUA(:,:,:),BWAQUA(:,:,:)
      END MODULE  ALLQUA
C=======================================================================
      MODULE      ALLQUZ
      SAVE        AWAQUZ       ,BWAQUZ
      COMPLEX     AWAQUZ       ,BWAQUZ
      ALLOCATABLE AWAQUZ(:,:,:),BWAQUZ(:,:,:)
      END MODULE  ALLQUZ
C=======================================================================
      MODULE      REDMOM
      SAVE        REDQ_P   ,REDM_P   ,REDS_P   ,INDRED
      COMPLEX     REDQ_P   ,REDM_P   ,REDS_P
      ALLOCATABLE REDQ_P(:),REDM_P(:),REDS_P(:),INDRED(:,:,:)
      END MODULE  REDMOM
C=======================================================================
      MODULE      REEMOM
      SAVE        REEQ_P   ,REEM_P   ,REES_P   ,INDREE
      COMPLEX     REEQ_P   ,REEM_P   ,REES_P
      ALLOCATABLE REEQ_P(:),REEM_P(:),REES_P(:),INDREE(:,:,:)
      END MODULE  REEMOM
C=======================================================================
      MODULE      GAUSTO
      SAVE        GAUFIL
      COMPLEX     GAUFIL
      ALLOCATABLE GAUFIL(:,:,:,:,:)
      SAVE        GAUAVR
      COMPLEX     GAUAVR
      ALLOCATABLE GAUAVR(:,:,:,:,:)
      END MODULE  GAUSTO
C=======================================================================
      MODULE      YUKSTO
      SAVE        YUKASV
      COMPLEX     YUKASV
      ALLOCATABLE YUKASV(:,:,:,:)
      END MODULE  YUKSTO
C=======================================================================
      MODULE      GOGSTO
      SAVE        GOGASV
      COMPLEX     GOGASV
      ALLOCATABLE GOGASV(:,:,:,:)
      END MODULE  GOGSTO
      MODULE      GOGKAP
      SAVE        GOGCHI
      COMPLEX     GOGCHI
      ALLOCATABLE GOGCHI(:,:,:,:)
      END MODULE  GOGKAP
C=======================================================================
      MODULE      ALISTO
      SAVE        ALINPP
      SAVE        ALINPM
      COMPLEX     ALINPP
      COMPLEX     ALINPM
      ALLOCATABLE ALINPP(:,:,:,:,:)
      ALLOCATABLE ALINPM(:,:,:,:,:)
      END MODULE  ALISTO
C=======================================================================
      MODULE      PLISTO
      SAVE        PLINPP
      SAVE        PLINPM
      COMPLEX     PLINPP
      COMPLEX     PLINPM
      ALLOCATABLE PLINPP(:,:,:,:,:)
      ALLOCATABLE PLINPM(:,:,:,:,:)
      END MODULE  PLISTO
C=======================================================================
      MODULE      AROSTO
      SAVE        AROTPP
      SAVE        AROTPM
      COMPLEX     AROTPP
      COMPLEX     AROTPM
      ALLOCATABLE AROTPP(:,:,:,:,:)
      ALLOCATABLE AROTPM(:,:,:,:,:)
      END MODULE  AROSTO
C=======================================================================
      MODULE      PROSTO
      SAVE        PROTPP
      SAVE        PROTPM
      COMPLEX     PROTPP
      COMPLEX     PROTPM
      ALLOCATABLE PROTPP(:,:,:,:,:)
      ALLOCATABLE PROTPM(:,:,:,:,:)
      END MODULE  PROSTO
C=======================================================================
      MODULE      COUSTO
      SAVE        COULSV
      COMPLEX     COULSV
      ALLOCATABLE COULSV(:,:,:)
      SAVE        COULFL
      COMPLEX     COULFL
      ALLOCATABLE COULFL(:,:,:)
      END MODULE  COUSTO
C=======================================================================
      MODULE      CYLTRA
      SAVE        AUXCYL
      COMPLEX     AUXCYL
      ALLOCATABLE AUXCYL(:,:)
      END MODULE  CYLTRA
C=======================================================================
      MODULE      FRAGFL
      SAVE        F_FLAG
      ALLOCATABLE F_FLAG(:,:,:)
      END MODULE  FRAGFL
C=======================================================================
      MODULE      CANONI
      SAVE        CANANG,CANPAR,CANENE,WAVCAN
      COMPLEX     WAVCAN
      ALLOCATABLE CANANG(:,:,:),CANPAR(:,:,:),CANENE(:,:,:)
      ALLOCATABLE WAVCAN(:,:,:,:)
      END MODULE  CANONI
C=======================================================================
      MODULE      DENCON
      SAVE        DCONTI
      COMPLEX     DCONTI
      ALLOCATABLE DCONTI(:,:,:)
      END MODULE  DENCON
C=======================================================================
