 MODULE params

      IMPLICIT NONE

      ! Divers
      INTEGER, PARAMETER :: NDOMEG=5,NDNUCL=1,NDPROT=140,NDNEUT=250
      INTEGER, PARAMETER :: NDCASE=2,IBATES=1
      INTEGER, PARAMETER :: NDSEAR=10,NRANDO=500,NDSIZE=NDSEAR,NDMINI=NDSEAR,NDTEST=1000,NDREST=21
      INTEGER, PARAMETER :: NDKART=3,NDREVE=1,NDISOS=1,NDPARI=1,NDSPIN=1
      INTEGER, PARAMETER :: NDSYMM=1,NDKONF=3,NDSPLN=100,NDDERI=2,NDSCAL=1
      INTEGER, PARAMETER :: NDMAXW=200,NDELEM=60,NDLNGT=256,NDX256=256
      INTEGER, PARAMETER :: NDSUBR=30,NDCOLU=4,NDAUXI=5,NDINFO=2,NDTERM=15
      INTEGER, PARAMETER :: NPHMAX=50,ND_ARG=68,NDFNCT=10,NTHMAX=50,NDPRNT=34,NDRNGE=67,NDLINE=67
      INTEGER, PARAMETER :: NDMOLL=9000,NDWERN=2000,NDVALS=3000,NDSMTH=20
      ! HO Basis
      INTEGER, PARAMETER :: NDBASE=1200,NDSTAT=NDBASE,NDDOUB=2*NDBASE,NDOUBL=2*NDBASE
      INTEGER, PARAMETER :: MDBASE=NDBASE*IBATES+1-IBATES,MDBAS2=2*MDBASE
      INTEGER, PARAMETER :: NDTRIA=NDOUBL*(NDOUBL+1)/2,NDAUX1=2*NDOUBL-1,NDAUX2=3*NDOUBL-2
      INTEGER, PARAMETER :: NDMAIN=30,NDOSGS=30,ND2MAX=2*NDOSGS+2
      INTEGER, PARAMETER :: NDFACT=4*NDMAIN-1
      INTEGER, PARAMETER :: NDXMAX=NDMAIN,NDYMAX=NDMAIN,NDZMAX=NDMAIN
      INTEGER, PARAMETER :: NDOSCI=30,NDBTOT=(NDOSCI+1)**3
      ! Integrations
      INTEGER, PARAMETER :: NDXHRM=40,NDYHRM=40,NDZHRM=66,NDGAUS=NDZHRM,NDPNTS=2*NDGAUS
      INTEGER, PARAMETER :: NDHMAX=NDXHRM*NDYHRM*NDZHRM,NDSCHR=1
      INTEGER, PARAMETER :: NDPHTH=300,ND_THE=50,ND_PHI=50
      INTEGER, PARAMETER :: NDMSHT=30,NDMSHF=NDMSHT/2+5
      INTEGER, PARAMETER :: NDLAGE=NDMAIN,MAXLEG=8,NDMESH=500
      INTEGER, PARAMETER :: NDHERM=2*NDMAIN+1
      INTEGER, PARAMETER :: NDXDEN=66,NDYDEN=66,NDZDEN=66,NDDENS=NDZDEN
      ! Labels (at the moment all sizes for cylindrical and spherical are identical)
      INTEGER, PARAMETER :: NDPR14=14,NDOLAB=7,NDCLAB=7,NDPERP=NDCLAB
      INTEGER, PARAMETER :: NDJSPH=2*NDOLAB+1,MDJSPH=NDJSPH*IBATES+1-IBATES
      INTEGER, PARAMETER :: NDMODD=(NDCLAB+1)*(NDCLAB+3)*(NDCLAB+NDCLAB+7)/24
      INTEGER, PARAMETER :: NDMEVE=(NDCLAB+2)*(NDCLAB+4)*(NDCLAB+NDCLAB+3)/24
      ! If NDCLAB=EVEN => NDTRAN should be equal NDMEVE
      ! If NDCLAB= ODD => NDTRAN should be equal NDMODD
      INTEGER, PARAMETER :: NDTRAN=NDMODD,MDTRAN=NDTRAN*IBATES+1-IBATES
      INTEGER, PARAMETER :: NDTVEC=(NDCLAB+1)*(NDCLAB+2)*(NDCLAB+3)/3,MDTVEC=NDTVEC*IBATES+1-IBATES
      INTEGER, PARAMETER :: NDTVE2=2*MDTVEC,MDTVE2=2*MDTVEC,NDSPHE=25,NDSH12=91
      INTEGER, PARAMETER :: MDMAIN=NDOLAB*IBATES+1-IBATES
      ! Deformations
      INTEGER, PARAMETER :: NDLAMB=9,NDMULT=NDLAMB,NDTETR=4,NDOKTR=4,NDDEFO=1
      ! Pairing
      INTEGER, PARAMETER :: NDPAIR=200,ITEMAX=200
      INTEGER, PARAMETER :: NDWSOD=NDBASE,NDWAUX=4*NDWSOD,ND_ANG=150
      INTEGER, PARAMETER :: NDLEVS=NDBASE,NDBLOK=4


 END MODULE params
