C FILE NAME = wsu02_exec_06.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====  MAIN CALLING SEQUENCE         ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SHOWOF(NDGAUS,MDGAUS,NDZHRM,NDOSGS,VERSIO)
      CHARACTER
     *          VERSIO*5
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C     Testing the declaration consistency for  NDGAUS  and  NDGOSC
C=======================================================================
C
      IF (NDGAUS.LT.MDGAUS) THEN
          WRITE(NOUTPT,'(/,''NDGAUS='',I3,'' must be greater than: '',
     *                     ''MDGAUS='',I3)') NDGAUS,MDGAUS
          STOP 'Correct declaration of NDGAUS in WSEXEC - '
      END IF
C
      IF (NDZHRM.LT.2*NDOSGS+3) THEN
C
          WRITE(NOUTPT,'(//,''You must guarantee that '',
     *                   ''NDZHRM.ge.2*NDOSGS+3; modify '',
     *                   ''dimensions; look for : c! symbol'')')
C
          STOP 'Wrong dimension declaration: NDZHRM.LT.2*NDOSGS+3 <<= '
C
      END IF
C
C     Defining the version number of the code
C                           ___________________
C                          |                  |
                              VERSIO='1.00'
C                          |__________________|
C
      IF (IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(80(''#''),/,80(''#''),/,
     *                                  ''#'',78X,''#'',/,''#'',05X,
     *       8(''WSUNIV   ''),1X,       ''#'',/,''#'',78X,''#'',/,
     *       80(''#''),   /,80(''#''),/,''#'',78X,''#'',/,''#'',05X,
     *       ''DEFORMED NUCLEAR MEAN-FIELD CODE - '',
     *       ''WOODS-SAXON POTENTIAL VERSION '',A5,3X,
     *                          ''#'',/,''#'',78X,''#'',/,''#'',05X,
     *       ''THIS IMPLEMENTATION: ''
     *       ''ONE SYMMETRY-PLANE AND NO TIME-REVERSAL SYMMETRY  '',
     *                                        02X,''#'',/,''#'',T28,
     *       ''DEFORMED  CARTESIAN  HARMONIC  OSCILLATOR  BASIS  '',
     *                                        02X,''#'',/,''#'',T28,
     *       ''DIRAC- AND/OR TRADITIONAL SCHROEDINGER EQUATIONS  '',
     *                                        02X,''#'',/,''#'',T28,
     *       ''2-D CRANKING; MULTIPOLE MOMENTS; SPATIAL DENSITY  '',
     *                                T80,''#'',/,''#'',78X,''#'',/,
     *                    80(''#''),/,80(''#''),/,''#'',78X,''#'',/,
     *       ''#              Jerzy DUDEK, Jacek '',
     *       ''DOBACZEWSKI and Nicolas SCHUNCK              #'',
     *                     /,''#'',78X,''#'',/,''#'',13X,
     *       ''Centre de Recherches Nucleaires, Strasbourg, 1993-97'',
     *                      13X,''#'',/,''#'',78X,''#'',/,''#'',11X,
     *       ''Institut des Recherches Subatomiques, Strasbourg, '',
     *       ''1997-04'',10X,''#'',/,''#'',78X,''#'',/,80(''#''),/,
     *                                                 80(''#''),//)')
     *
     *       VERSIO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_WSEXEC(IZ_FIX,IN_FIX,FILE_P,FILE_N,NAMEFI,ISOSPI,
     *                     P_ONLY,N_ONLY,OMEGAX,OMEGAY,OMEGAZ,OMEGA3,
     *                                   NOFOME,VERSIO,I_CALL,SELPAR)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          SELPAR*20,VERSIO*5,NUNITS*3,NUCAVR*7
      CHARACTER
     *          FILE_P*256,FILE_N*256,NAMREV*4
      CHARACTER
     *          FILWOO*68
      CHARACTER
     *          RYTEXT(0:NDREVE)*5
      CHARACTER
     *          P_ONLY*3,N_ONLY*3
C
      COMPLEX
     *          ALPHAC,BETBAS
      COMPLEX
     *          ASTORE(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      DIMENSION
     *          N_BLOK(1:NDLEVS)
      DIMENSION
     *          GPAIRT(0:NDISOS),DELTAT(0:NDISOS),
     *          XLAMBT(0:NDISOS),PPROJT(0:NDISOS),
     *          PAICOT(0:NDISOS),PAICLT(0:NDISOS)
      DIMENSION
     *          OMEGAX(0:NDOMEG),OMEGAY(0:NDOMEG),
     *          OMEGAZ(0:NDOMEG),OMEGA3(0:NDOMEG)
      DIMENSION
     *          CPHASE(0:NDOSGS,0:NDOSGS,0:NDKART)
      DIMENSION
     *          VCENTR(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VEFMAS(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VSORBT(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VLIMOM(1:NDXHRM,1:NDYHRM,1:NDZHRM)
      DIMENSION
     *          IPAORD(1:NDBASE)
      DIMENSION
     *          TOTROU(0:NDOMEG,0:NDISOS),
     *          TOTSPI(0:NDOMEG,0:NDISOS)
C
      COMMON
     *       /HFBASE_BASE_2/ BASEX2,BASEY2,BASEZ2
      COMMON
     *       /WSEXEC_V2OCCU/ V2OCCU(1:NDBASE)
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
      COMMON
     *       /EXTRAS_FERMIS/ EFERMN,EFERMP
     *       /EXTRAS_DELTAS/ DLININ,DLINIP
     *       /EXTRAS_PAIRCO/ EPNBAR,EPPBAR
     *       /EXTRAS_PSTRNG/ GPAIRN,GPAIRP
      COMMON
     *       /PAIRIN_ALLGAP/ DELTAN,DELTAP
     *       /PAIRIN_STRENG/ GFACTN,GFACTP
     *       /PAIRIN_SWITCH/ IFPAIR,IFPROJ,IF_BCS,IF_LIP
      COMMON
     *       /CONSER_SIMPLY/ ISIMPY
      COMMON
     *       /CONTROLIN_ENE/ EMINST,EMAXST,EMINWF,EMAXWF,SPHMAX,EMINCH,
     *                                                          EMAXCH
     *       /CONTROLIN_ARG/ XCUT_P,YCUT_P,ZCUT_P,ARGMIN,ARGMAX
     *       /CONTROLIN_MOD/ MODE_X,MODE_Y,MODE_Z
     *       /CONTROLIN_LIN/ NOFLIN
      COMMON
     *       /GAUSSINTG_HER/ NXHERM,NYHERM,NZHERM,IOPTGS
     *       /GAUSSINTG_ANG/ NTHPNT,NFIPNT
     *       /GAUSSINTG_EPS/ EPSHER
      COMMON
     *       /LABELLING_WAV/ KARWAV,MAXWAV,NILWAV,IWAVSP
     *       /LABELLING_CNT/ KARTLB,MAXXYZ,NILSLB
     *       /LABELLING_SPH/ LABSPH,LABSPE
      COMMON
     *       /SETBAS_NOSMAX/ MAXBNX,MAXBNY,MAXBNZ,NOSMAX
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
     *       /PARAMS_R0PARM/ R0PARM
      COMMON
     *       /SPHERICAL_WAV/ IFWAVE
     *       /LABELLING_ONN/ LBATES
      COMMON
     *       /PLOSHAPES_IPL/ IPLOP1,IPLOP2,IPLOTH
     *       /PLOSHAPES_PHI/ PHIPL1,PHIPL2
      COMMON
     *       /NOSCILCUT_NOS/ NOSCIL,NLIMIT,ISOTRO
     *       /NOSCILCUT_ENE/ ENECUT,FCHOM0
      COMMON
     *       /NUCLEONIC_DEN/ IFDENI,IFDENS,IF_XYZ
     *       /NUCLEONIC_UNI/ NUNITS,NUCAVR
     *       /NUCLEONIC_RMX/ R_MAXI
      COMMON
     *       /WIGNERROT_ANG/ ALFAWG,BETAWG,GAMAWG
     *       /WIGNERROT_IFW/ IFWIGN
      COMMON
     *       /PRECISION_EPS/ EPSF_S,EPSG_S,APROAC
     *       /PRECISION_MSH/ MESHTH,ITERNS
      COMMON
     *       /MULTIPOLE_LMU/ IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
      COMMON
     *       /SIGNATURE_FIX/ ISIGNY,IAUTOM
      COMMON
     *       /DELTAFRCE_INT/ IFDELT,LIMLOW,LIMUPP
C
      COMMON
     *       /CRANKINGX_NOF/ KRANKX,NOFOMX,ISPINX
     *       /CRANKINGX_OME/ OMEGX0,STEPOX,SPIN_X
      COMMON
     *       /CRANKINGY_NOF/ KRANKY,NOFOMY,ISPINY
     *       /CRANKINGY_OME/ OMEGY0,STEPOY,SPIN_Y
      COMMON
     *       /CRANKINGZ_NOF/ KRANKZ,NOFOMZ,ISPINZ
     *       /CRANKINGZ_OME/ OMEGZ0,STEPOZ,SPIN_Z
      COMMON
     *       /CRANKING3_ANG/ THEANG,PHIANG,KRANK3
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
      COMMON
     *       /HFBASE_DEFORM/ BETBAS(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
     *       /REALALMUL_DEF/ IREALA
C
      COMMON
     *       /WSEXEC_HERSTO/ HERMTS(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /WSEXEC_DIVSTO/ DHRMTS(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                       DDHRMT(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /WSEXEC_INTSTO/ HERWGT(1:NDGAUS,1:NDKART),
     *                       HERPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /WSGEOM_GAUS2L/ XPOINT(1:NDPHTH),XWEIGH(1:NDPHTH),
     *                       YPOINT(1:NDPHTH),YWEIGH(1:NDPHTH)
C
      DATA
     *     RYTEXT /  '(+,+)' ,  '(-,-)' /
C
C=======================================================================
C     In series 4 of the WS codes this routine calls all the principal
C     routines of the WS algorithm, setting up the basis, defining the
C     geometrical parameters, defining the potentials, hamiltonian and
C     related  (matrices, taking into account symmetries)  and finally
C     obtaining the spectrum - in the earlier versions those functions
C     were executed by the main program.
C=======================================================================
C
      MAXLAM=LAMMAX
C
C     Testing the declaration consistency for NDGAUS
C
      MDGAUS=MAX(NDXHRM,NDYHRM,NDZHRM,2*NDOSGS+3)
C
      IF (NDGAUS.LT.MDGAUS) THEN
          WRITE(NOUTPT,'(/,''NDGAUS='',I3,'' must be greater than: '',
     *                     ''MDGAUS='',I3)') NDGAUS,MDGAUS
          STOP 'Please correct the declaration of NDGAUS in WSEXEC - '
      END IF
C
      IF (ISOSPI.EQ.0.AND.N_ONLY.NE.'YES') RETURN
      IF (ISOSPI.EQ.1.AND.P_ONLY.NE.'YES') RETURN
C
      IF (IWRITE.GE.1) THEN
C
          IF (ISCREN.EQ.1.AND.ISOSPI.EQ.0) THEN
              WRITE(0,'(/,''Starting deformation point No.'',I4,
     *                                        '': NEUTRONS'')')
     *                      I_CALL
          END IF
C
          IF (ISCREN.EQ.1.AND.ISOSPI.EQ.1) THEN
              WRITE(0,'(/,''Starting deformation point No.'',I4,
     *                                        '':  PROTONS'')')
     *                      I_CALL
          END IF
C
      END IF
C
      PINUMB=4.0*ATAN(1.0)
      THEPLO=0.5000000*PINUMB
C
C      Defining  the natural  constants common for the run
C
      CALL WS_NCONST(NUNITS,NUCAVR)
C
C      Checking for the possible input inconsistencies  (1)
C
C      Attention:  The number of Gauss points must be even;
C      this is because the plane symmetries are programmed
C      explicitly avoiding integrations with {x,y, or z}=0
C
      IF (MOD(NXHERM,2).NE.0) NXHERM=NXHERM+1
      IF (MOD(NYHERM,2).NE.0) NYHERM=NYHERM+1
      IF (MOD(NZHERM,2).NE.0) NZHERM=NZHERM+1
C
C      Subroutine defining the standard sets  of the potential
C      parameters; several standard choices are pre-programmed
C      here see comments inside
C
      CALL WS_PARAMS(IZ_FIX,IN_FIX,ISOSPI,R0PARM,NOEFFM,SELPAR)
C
C      Defining  parameters of the harmonic oscillator basis.
C      The deformation of the basis is different from that of
C      the physical surface.
C
      DO LAMBDA=0,NDLAMB
         DO MIU=-NDLAMB,NDLAMB
            ASTORE(LAMBDA,MIU)=ALPHAC(LAMBDA,MIU)
            ALPHAC(LAMBDA,MIU)=BETBAS(LAMBDA,MIU)
         END DO
      END DO
C
      CALL WS_LIMITY(ALPHAC)
C
      CALL WS_GEOMFC(IZ_FIX,IN_FIX,FCHOM0,R0PARM,HOMEGA,
     *                             MAXLAM,ISOTRO,CVOLFC,
     *                             CMSXFC,CMSYFC,CMSZFC,
     *                             XMOMFC,YMOMFC,ZMOMFC)
C
      RCVOLM=RADIUS*CVOLFC
C
      NXMAXX=0
      NYMAXX=0
      NZMAXX=0
C
      CALL WS_SETBAS(IZ_FIX,IN_FIX,ISOSPI,NOSCIL,NLIMIT,ENECUT,
     *                             IOPTGS,NXHERM,NYHERM,NZHERM,
     *                             FCHOM0,BASEX2,BASEY2,BASEZ2,
     *                             ISOTRO,NXMAXX,NYMAXX,NZMAXX)
C
      DO LAMBDA=0,NDLAMB
         DO MIU=-NDLAMB,NDLAMB
            ALPHAC(LAMBDA,MIU)=ASTORE(LAMBDA,MIU)
         END DO
      END DO
C
      CALL WS_LIMITY(ALPHAC)
C
C      The y-simplex is conserved by default. In the case of 3D-cranking
C      is may be broken, ISIMPY => 0. This flag is mostly used for
C      multipole moments calculations.
C
      ISIMPY=1
C
      MU_ODD=0
C
      DO LAMBDA=1,NDLAMB
          DO MIU=1,LAMBDA,2
             IF (ABS(ALPHAC(LAMBDA,MIU)).GT.1.0E-10) MU_ODD=1
          END DO
      END DO
                       KRANKG=0
      IF (KRANKX.NE.0) KRANKG=1
      IF (KRANKY.NE.0) KRANKG=2
      IF (KRANKZ.NE.0) KRANKG=3
      IF (KRANK3.NE.0) KRANKG=-1
C
C      Printing the overall summary of option params. used
C
      IF (IWRITE.GE.1) CALL WS_SUMARY
C
C      Defining  standard-file-names  for the result files
C
      CALL WS_NAMFIL(NAMEFI,IZ_FIX,IN_FIX,FILE_P,FILE_N,
     *                                    ALPHAC,NDLAMB)
C
C      Below, the negative-miu components in nuclear shape
C      are  defined from the condition that the surface is
C                                                 r e a l
C
      DO LAMBDA=0,MAXLAM
         DO MIU=1,LAMBDA
            ALPHAC(LAMBDA,-MIU)=(-1)**MIU*CONJG(ALPHAC(LAMBDA,MIU))
         END DO
      END DO
C
C      Defining the mode:  <labels_on>   or   <labels_off>
C
      IF (IBATES.NE.LBATES) THEN
C
          IF (IBATES.EQ.0) STOP 'PROGRAM not in label version <<= '
          IF (IBATES.NE.0) STOP 'PROGRAM is  in label version <<= '
C
      END IF
C
C      Turning the nucleus in space using the Wigner functions
C      Attention: these transformations can only be used  when
C      the corresponding rotations  bring a simplex-conserving
C      system into a position where the simplex is conserved -
C      In order to turn freely in space we need the full space
C      dimension rather than the half of it, as in the case of
C      the explicit simplex (time-reversal) conservation
C
      CALL WS_ROTWIG(IFWIGN,MAXLAM,ALFAWG,BETAWG,GAMAWG,
     *                                    ALPHAC,NDLAMB)
C
C      Setting the numerical factors for calculating Y_(lm)' s
C
      CALL WS_LOADIN(MAXLAM)
C
C      Printing information  about the actual  deformation set
C
      IF (IWRITE.GE.1) CALL WS_DEFPRI(MAXLAM,IZ_FIX,IN_FIX)
C
C      Automatic test of symmetries (spherical, axial, parity)
C
      CALL WS_VERIFS(MAXLAM,ALPHAC,NDLAMB)
C
C      Defining units for the multipole moments
C
      CALL WS_DEFUNI(MAXMUL)
C
C      Opening the permanent and scratch files
C
      CALL WS_OPENFI(IZ_FIX,IN_FIX,ISOSPI,FILE_P,FILE_N)
C
C      Calculating the auxiliary,  geometrical factors related
C      to the constant volume condition,  classical moments of
C      inertia, and the centre-of-mass shifts
C
      IFBASE=0
C
      XLOWER=0.0
      YLOWER=0.0
      XUPPER=PINUMB
      YUPPER=2.0000*PINUMB
C
      CALL WS_GAULEG(XLOWER,XUPPER,XPOINT,XWEIGH,NTHPNT,NDPHTH)
C
      CALL WS_GAULEG(YLOWER,YUPPER,YPOINT,YWEIGH,NFIPNT,NDPHTH)
C
      CALL WS_GEOMFR(CMSXFC,CMSYFC,CMSZFC,XMOMFC,YMOMFC,ZMOMFC,
     *               CVOLFC,NTHPNT,NFIPNT,IZ_FIX,IN_FIX,R0PARM,
     *                                                  IFBASE)
C
      RCVOLM=RADIUS*CVOLFC
C
C      Defining the cranking frequencies up to 'maximum spin'
C
      CALL WS_OMSPIN(OMEGAX,OMEGAY,OMEGAZ,NOFOMX,NOFOMY,NOFOMZ,
     *               XMOMFC,YMOMFC,ZMOMFC,SPIN_X,SPIN_Y,SPIN_Z,
     *                                    ISPINX,ISPINY,ISPINZ)
C
C=======================================================================
C                       P R E P A R I N G
C             N U M E R I C A L   I N T E G R A T I O N S
C=======================================================================
C
C      Definition,  in DEVHER, of general expansion coeffs.
C      To express the products  of two Hermite polynomials,
C      products of one polynomial  and a derivative etc by
C      a series of single Hermite polynomials...
C
C      Just below  we call  DEFINT,  defining the harmonic
C      oscillator wave functions  together  with the Gauss-
C      Hermite  integration  points  and weights.  Hermite
C      polynomials  HERMTS  are normalised  as usual,  i.e.
C      the norm contains SQRT(mc^2*homega/h_barc**2).
C
      NOBODY=1 ! Number of single-particle 'bodies' (1-body)
      IDERIV=2 ! The highest derivative order of Hermites =2
C
                       LEVELD=1
      IF (IFMULT.EQ.1) LEVELD=3
      KARTEZ=1
C
C     Recall: NXHERM - The number  of the Gauss  integration
C                      points along the x-direction while...
C
C             NXMAXX - Maximum order  of the polynomial that
C                      depends on the x-variable
C
      NGAUSS=NXHERM
      NOSACT=NXMAXX
C
C     In short: Expanding product of 2 polynomials into sums
C
      CALL WS_DEVHER(NOSACT,EPSHER,KARTEZ,NGAUSS)
C
C     In short: Define integration auxiliaries (nodes,  ...)
C
      CALL WS_DEFINT(NOSACT,EPSHER,KARTEZ,NGAUSS,NOBODY,IDERIV,
     *                      HERMTS,DHRMTS,DDHRMT,HERWGT,HERPNT)
C
C     In short: Preparatory integrals of powers of {x,y,z}
C
      CALL WS_DEVMUL(NOSACT,NGAUSS,KARTEZ,MAXMUL,LEVELD,IFMULT)
C
                       LEVELD=1
      IF (IFMULT.EQ.1) LEVELD=3
      KARTEZ=2
C
      NGAUSS=NYHERM
      NOSACT=NYMAXX
C
      CALL WS_DEVHER(NOSACT,EPSHER,KARTEZ,NGAUSS)
C
      CALL WS_DEFINT(NOSACT,EPSHER,KARTEZ,NGAUSS,NOBODY,IDERIV,
     *                      HERMTS,DHRMTS,DDHRMT,HERWGT,HERPNT)
C
      CALL WS_DEVMUL(NOSACT,NGAUSS,KARTEZ,MAXMUL,LEVELD,IFMULT)
C
                       LEVELD=1
      IF (IFMULT.EQ.1) LEVELD=3
      KARTEZ=3
C
      NGAUSS=NZHERM
      NOSACT=NZMAXX
C
      CALL WS_DEVHER(NOSACT,EPSHER,KARTEZ,NGAUSS)
C
      CALL WS_DEFINT(NOSACT,EPSHER,KARTEZ,NGAUSS,NOBODY,IDERIV,
     *                      HERMTS,DHRMTS,DDHRMT,HERWGT,HERPNT)
C
      CALL WS_DEVMUL(NOSACT,NGAUSS,KARTEZ,MAXMUL,LEVELD,IFMULT)
C
C      Defining units  for the quadrupole moments in DEFUNI &
C      the solid harmonics in DEFYLM
C
      CALL WS_DEFYLM
C
C      Testing symmetries:  reflections,  rotation angles ...
C
      CALL WS_TESSYM
C
C      Setting  an auxiliary mesh  in theta and phi angles to
C      accelerate  the calculations  of the distance function
C
      CALL WS_INMESH(MESHTH)
C
C=======================================================================
C                    D I A G O N A L I Z A T I O N
C                             O F   T H E
C             W O O D S - S A X O N   H A M I L T O N I AN
C=======================================================================
C
C      Calculating the matrix elements of the hamiltonian and
C      consecutive diagonalization, within subroutine  CELMAT.
C
C      Note: Here we need only one diagonalisation  (IREVER=0)
C      ====  for one simplex - this call is used  with no-rot.
C            case; for the cranking calls - see below.
C
C      The potentials: VCENTR, VEFMAS, VSORBT and VLIMOM  are
C      defined in CELMAT through DEFPOT; they are the results
C      of the call below.
C
      IREVER=0
C
      CALL WS_SPECTR(ISOSPI,NOSCIL,ISIGNY,IREVER,IPAORD,NOEFFM,
     *               NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *               VCENTR,VEFMAS,VSORBT,VLIMOM,ENECUT,EPSHER,
     *                                    LDBASE,MU_ODD,KRANKG)
C
C      Calculating the pairing correction (only in no-cranking case)
C
      DO I=1,NDBASE
         V2OCCU(I)=0.0
      END DO
C
                       NFERMI=IN_FIX/2+MOD(IN_FIX,2)
      IF (ISOSPI.EQ.1) NFERMI=IZ_FIX/2+MOD(IZ_FIX,2)
C
      DO I=1,NFERMI
         V2OCCU(I)=1.0
      END DO
C
      IF (IFPAIR.EQ.1) THEN
C
          CALL WS_SETDEL(IZ_FIX,IN_FIX,ISOSPI,I_FAIL,LDBASE,FCHOM0)
C
          IF (IF_BCS.EQ.1) THEN
C
              NLPAIR=LDBASE
C
              IFSUMG=0
              I_PROJ=1
C
	      IF (ISOSPI.EQ.0) THEN
		  XLAMBD=EFERMN
		  G_PAIR=GPAIRN
		  FACTOG=GFACTN
		  BCSBAR=EPNBAR
		  N_PART=IN_FIX
	      ELSE
		  XLAMBD=EFERMP
		  G_PAIR=GPAIRP
		  FACTOG=GFACTP
		  BCSBAR=EPPBAR
		  N_PART=IZ_FIX
	      END IF
C
C              If Npart is odd, then one level is blocked
C
              IF (MOD(N_PART,2).EQ.1) THEN
C
                  LFERMI=N_PART/2
C
	          NOFBLK=1
	          N_BLOK(1)=LFERMI+1
C
              ELSE
C
	          NOFBLK=0
C
              END IF
C
              CALL WS_BCSPAI(IZ_FIX,IN_FIX,ISOSPI,NLPAIR,NOFBLK,N_BLOK,
     *                       FACTOG,G_PAIR,XLAMBD,PDELTA,PCOREL,PCOREC,
     *                       I_PROJ,IFSUMG,PROJ_E,ESINGP,BCSBAR,PAIREN,
     *                                     PROJCR,SUMSNG,SUMGPA,V2OCCU)
C
c              CALL WS_BCSOUT(IZ_FIX,IN_FIX,ISOSPI,G_PAIR,FACTOG,PDELTA,
c     *                              PCOREL,PCOREC,NLPAIR,ESINGP,V2OCCU)
C
	      IF (ISOSPI.EQ.0) THEN
		  EFERMN=XLAMBD
		  GPAIRN=G_PAIR
		  DELTAN=PDELTA
	      ELSE
		  EFERMP=XLAMBD
		  GPAIRP=G_PAIR
		  DELTAP=PDELTA
	      END IF
C
          END IF
C
          IF (IFPROJ.EQ.1) THEN
C
              IPRINT=1
C
              CALL WS_PNPROJ(IZ_FIX,IN_FIX,ISOSPI,LDBASE,GPAIRT,DELTAT,
     *                       XLAMBT,PPROJT,PAICOT,PAICLT,V2OCCU,IPRINT)
C
          END IF
C
          IF (IF_LIP.EQ.1) THEN
C
              ICODEL=0
	      IFSUMG=1
	      IPRINT=1
C
	      IF (ISOSPI.EQ.0) THEN
	          DELLIP=DLININ
		  EFERMI=EFERMN
	      ELSE
	          DELLIP=DLINIP
		  EFERMI=EFERMP
	      ENDIF
C
              CALL WS_PAIRLN(IZ_FIX,IN_FIX,LDBASE,ESINGP,ICODEL,DELLIP,
     *                       PAICON,PCOREL,IFSUMG,EFERMI,XLAMB2,ISOSPI,
     *                                                   V2OCCU,IPRINT)
C
          END IF
C
      END IF
C
C      Printing the actual deformation table
C
      IF (IWRITE.GE.1) CALL WS_DEFPRI(MAXLAM,IZ_FIX,IN_FIX)
C
C=======================================================================
C        C O M P U T I N G   V A R I O U S   O B S E R V A B L E S
C=======================================================================
C
C      The following subroutine is called in order to keep a
C      compatibility with HF code, as the set of subroutines
C      which calculate quadrupole moments has been  imported
C      from the HF code
C
      CALL WS_PHASES(CPHASE,NYMAXX)
C
C      Calculating and printing  the multipole moment  table
C
      KRANKI=0
      OMEGAC=0.0
C
      CALL WS_MOMETS(ISOSPI,IZ_FIX,IN_FIX,IFMULT,MAXMUL,NOFLEV,
     *                      KRANKI,ISIGNY,IINDIV,LAMIND,MIUIND)
C
      IF (IWRITE.GE.1) CALL WS_MOMPRI(MAXMUL,ISOSPI,IFMULT,OMEGAC,
     *                                                     KRANKI)
C
C      Magnetic moments
C
c      CALL WS_MAGMOM(ISOSPI,IZ_FIX,IN_FIX,IFMULT,MAXMUL,KRANKI,
c     *                                    IINDIV,LAMIND,MIUIND)
C
c      IF (IWRITE.GE.1) CALL WS_MAGPRI(MAXMUL,ISOSPI,IFMULT,OMEGAC,
c     *                                                     KRANKI)
C
C      Calculating the spatial density and the root-m-square
C      radius;  everything optional, IFDENS=1,  else  RETURN
C      DENSSP   performs the calculations for a special mesh,
C               for future plotting of the nucleonic density
C
      CALL WS_DENSSP(NXMAXX,NYMAXX,NZMAXX,NXHERM,NYHERM,NZHERM,
     *               ISOSPI,IZ_FIX,IN_FIX,IFDENS,NOBODY,R_MAXI)
C
C      Subroutine DENINT calculates the denisty at the Gauss
C      points and the root-mean square radius - if  IFDENI=1
C
      CALL WS_DENINT(NXMAXX,NYMAXX,NZMAXX,NXHERM,NYHERM,NZHERM,
     *               ISOSPI,IZ_FIX,IN_FIX,D_NORM,RMSRAD,RADIUS,
     *                                                  IFDENI)
C
C          ... similar to the above but only for the sphere
C
      CALL WS_RMSCUT(NXMAXX,NYMAXX,NZMAXX,NXHERM,NYHERM,NZHERM,
     *               ISOSPI,IZ_FIX,IN_FIX,RMSRAD,RADIUS,IF_XYZ,
     *                             BASEX2,BASEY2,BASEZ2,EPSHER)
C
C      Calculating the matrix elements of the two-body delta
C      interaction
C
      CALL WS_DELTJK(NXMAXX,NYMAXX,NZMAXX,NXHERM,NYHERM,NZHERM,
     *               LIMLOW,LIMUPP,ISOSPI,IZ_FIX,IN_FIX,IFDELT,
     *                                           EPSHER,NOSCIL)
C
C      Cartesian basis: labelling  states and wave functions
C
      OMEGAC=0.0
C
      CALL WS_LBKART(IZ_FIX,IN_FIX,ISOSPI,EMINST,EMAXST,KARTLB,
     *               KARWAV,MAXXYZ,MAXWAV,EMINWF,EMAXWF,OMEGAC,
     *                                           IREVER,RYTEXT)
C
C      Optionally calculating of the spherical labels at the
C      exact spherical symmetry limit
C
      CALL WS_SPHCRT(MAXLAM,LABSPE,NOSMAX,SPHMAX,EMINCH,EMAXCH,
     *                                    IREVER,IZ_FIX,IN_FIX)
C
C      Spherical basis transformations: labelling states and
C      wave functions
C
      CALL WS_KARSPH(NOSCIL)
C
      CALL WS_SPHONL(ISOSPI,NOFLIN,LABSPH,IWAVSP,EMINST,EMAXST,
     *               OMEGAC,ISIGNY,IPAORD,IREVER,EMINWF,EMAXWF,
     *               NOSCIL,ISOTRO,SPHMAX,RYTEXT,R_MAXI,IFWAVE)
C
C      Below  spectroscopic spherical labels  are calculated
C
      CALL WS_SPHLAB(MAXLAM,LABSPE,NOSMAX,SPHMAX,EMINCH,EMAXCH,
     *                                           IZ_FIX,IN_FIX)
C
C      Cylindrical basis  transformations:  labeling  states
C      and the wave functions
C
      CALL WS_CYLONL(ISOSPI,NILWAV,EMINST,EMAXST,OMEGAC,ISIGNY,
     *               NILSLB,IPAORD,IREVER,EMINWF,EMAXWF,RYTEXT)
C
C      Defining the second-simplex matrices for omega=0 case
C
      CALL WS_SETREV
C
C=======================================================================
C                   W R I T I N G   O N   D I S K
C=======================================================================
C
      IF (IWRITE.GE.1) THEN
C
C          Plotting the typical nuclear - shape cross - sections
C
          IF (IPLOP1.EQ.1) CALL WS_PLOTTH(MAXLAM,PHIPL1,IZ_FIX,IN_FIX)
C
          IF (IPLOP2.EQ.1) CALL WS_PLOTTH(MAXLAM,PHIPL2,IZ_FIX,IN_FIX)
C
          IF (IPLOTH.EQ.1) CALL WS_PLOTPH(MAXLAM,THEPLO,IZ_FIX,IN_FIX)
C
C          Plotting  the illustrative  potential cross - sections
C
          CALL WS_CUTPOT(ISOSPI,XCUT_P,MODE_X,YCUT_P,MODE_Y,ZCUT_P,
     *                                 MODE_Z,ARGMIN,ARGMAX,SELPAR)
C
	  FILWOO='wsodd.bin'
C
          CALL WS_WRIBIN(IZ_FIX,IN_FIX,FCHOM0,R0PARM,HOMEGA,EPSHER,
     *                          ENECUT,CVOLFC,CMSXFC,CMSYFC,CMSZFC,
     *                   XMOMFC,YMOMFC,ZMOMFC,BASEX2,BASEY2,BASEZ2,
     *                                 ALPHAC,IREALA,LDBASE,FILWOO)
C
C          Recording the results on disk ==>> (parameter heading)
C
          CALL WS_REVIDN(ALPHAC,IREALA,EPSHER,EPSF_S,EPSG_S,HOMEGA,
     *                   NXMAXX,NYMAXX,NZMAXX,CMSXFC,CMSYFC,CMSZFC,
     *                   XMOMFC,YMOMFC,ZMOMFC,BASEX2,BASEY2,BASEZ2,
     *                   CVOLFC,R0PARM,LDBASE,IZ_FIX,IN_FIX,ENECUT,
     *                          SELPAR,FCHOM0,VERSIO,ISOSPI,IFWAVE)
C
C         Recording the Woods-Saxon review file parameter tests
C
          CALL WS_REVPAR(IFWIGN,IZ_FIX,IN_FIX,KRANKX,KRANKY,KRANKZ,
     *                   ENECUT,NXHERM,NYHERM,NZHERM,ISOSPI,MAXMUL,
     *                          IF_XYZ,IFMULT,IREVER,IFDELT,IFWAVE)
C
C          Recording the Woods-Saxon review (cranking at omega=0)
C
          IF (KRANKG.GE.0) THEN
C
              OMEGAC=0
              NOMEGA=1
C
              CALL WS_REVOME(IFWIGN,IZ_FIX,IN_FIX,KRANKX,KRANKY,KRANKZ,
     *                       ISIGNY,ISOSPI,IFMULT,MAXMUL,OMEGAC,NOMEGA)
C
          ELSE
C
              OMEG_X=0.0
	      OMEG_Y=0.0
	      OMEG_Z=0.0
C
              CALL WS_COMP3D(ISOSPI,LDBASE)
C
              CALL WS_REVO3D(ISOSPI,IZ_FIX,IN_FIX,OMEG_X,OMEG_Y,OMEG_Z,
     *                       THEANG,PHIANG,NOFOME,LDBASE,IFMULT,MAXMUL)
C
          END IF
C
      END IF
C
C=======================================================================
C                 1 D   A N D   3 D   C R A N K I N G
C=======================================================================
C
C      1D Cranking: the cranking Hamiltonian is calculated,  and
C                   diagonalized
C
      IF (KRANKG.GT.0) THEN
C
C          Completing the (-,-) block for cranking: (-,-) = (+,+)
C
          CALL WS_PUT_MM(ISIGNY)
C
C          Diagonalization of the cranking hamiltonian
C
          CALL WS_CRANKG(IZ_FIX,IN_FIX,NOSCIL,NXMAXX,NYMAXX,NZMAXX,
     *                   LDBASE,NAMREV,ISOSPI,ISIGNY,IFMULT,MAXMUL,
     *                   KARTLB,KARWAV,NILSLB,LABSPH,ISOTRO,IFWIGN,
     *                   KRANKX,KRANKY,KRANKZ,KRANKG,NOFOME,MU_ODD,
     *                   MAXXYZ,MAXWAV,NILWAV,IWAVSP,NOFLIN,NOFLEV,
     *                   OMEGAX,OMEGAY,OMEGAZ,EMINWF,EMAXWF,SPHMAX,
     *                   CPHASE,RYTEXT,EMINST,EMAXST,IINDIV,LAMIND,
     *                                                      MIUIND)
C
      END IF
C
C      3D cranking
C
      IF (KRANKG.LT.0) THEN
C
C          Diagonalization of the cranking hamiltonian
C
          CALL WS_CRAN3D(IZ_FIX,IN_FIX,NXMAXX,NYMAXX,NZMAXX,LDBASE,
     *                   ISOSPI,NOFOME,NOFLEV,OMEGA3,KRANKG,THEANG,
     *                   PHIANG,RYTEXT,EMINST,EMAXST,EMINWF,EMAXWF,
     *                   NILWAV,NILSLB,TOTROU,TOTSPI,ISIGNY,IFMULT,
     *                                 MAXMUL,IINDIV,LAMIND,MIUIND)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INIOUT()
C=======================================================================
      USE params
C=======================================================================
C
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /LBKARR_SPLABS/ SPKART(1:NDBASE,0:NDREVE),
     *                       SPNILS(1:NDBASE,0:NDREVE),
     *                       SPORDE(1:NDBASE,0:NDREVE),
     *                       SPORDR(1:NDBASE,0:NDREVE)
      COMMON
     *       /LBKARR_QUOCAR/ QUOTCA(1:NDBASE,0:NDREVE)
     *       /SPHONL_QUOSPH/ QUOTSP(1:NDBASE,0:NDREVE)
     *       /CYLONL_QUOCYL/ QUOTCY(1:NDBASE,0:NDREVE)
C
      COMMON
     *       /LBKARR_BASCAR/ NXCART(1:NDBASE,0:NDREVE),
     *                       NYCART(1:NDBASE,0:NDREVE),
     *                       NZCART(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPHONL_SPHERE/ MAIN0S(1:NDBASE,0:NDREVE),
     *                       JMOM0S(1:NDBASE,0:NDREVE),
     *                       LSPH0S(1:NDBASE,0:NDREVE),
     *                       MMOM0S(1:NDBASE,0:NDREVE)
      COMMON
     *       /CYLONL_CYLIND/ MAINNL(1:NDBASE,0:NDREVE),
     *                       NZNILS(1:NDBASE,0:NDREVE),
     *                       L_NILS(1:NDBASE,0:NDREVE),
     *                       IOMEGA(1:NDBASE,0:NDREVE)
C
      COMMON
     *       /PUT_MM_SPNUMS/ NUMBSP(0:NDREVE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C
      NUMBSP(0)=1
      NUMBSP(1)=1
C
      LDBASE=1
C
      DO IREVER=0,NDREVE
         DO I_BASE=1,NDBASE
C
            SPENER(I_BASE,IREVER) = 0.0
            SPALIG(I_BASE,IREVER) = 0.0
            SPSPAL(I_BASE,IREVER) = 0.0
            SPPARI(I_BASE,IREVER) = 0.0
            QUOKAR(I_BASE,IREVER) = 0.0
            QUONIL(I_BASE,IREVER) = 0.0
C
	    SPKART(I_BASE,IREVER) = 0.0
            SPNILS(I_BASE,IREVER) = 0.0
            SPORDE(I_BASE,IREVER) = 0.0
            SPORDR(I_BASE,IREVER) = 0.0
C
            QUOTCA(I_BASE,IREVER) = 0.0
            QUOTSP(I_BASE,IREVER) = 0.0
            QUOTCY(I_BASE,IREVER) = 0.0
C
            NXCART(I_BASE,IREVER) = 0
            NYCART(I_BASE,IREVER) = 0
            NZCART(I_BASE,IREVER) = 0
C
            MAIN0S(I_BASE,IREVER) = 0
            JMOM0S(I_BASE,IREVER) = 0
            LSPH0S(I_BASE,IREVER) = 0
            MMOM0S(I_BASE,IREVER) = 0
C
            MAINNL(I_BASE,IREVER) = 0
            NZNILS(I_BASE,IREVER) = 0
            L_NILS(I_BASE,IREVER) = 0
            IOMEGA(I_BASE,IREVER) = 0
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PREDEF(NOFOME,OMEGAX,OMEGAY,OMEGAZ)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          FILE_P*256,FILE_N*256
C
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI,BETBAS
C
      CHARACTER
     *          NUNITS*3,NUCAVR*7,N_ONLY*3,P_ONLY*3
      CHARACTER
     *          SELPAR*20
C
      INTEGER
     *          HISITE
C
      DIMENSION
     *          OMEGAX(0:NDOMEG),
     *          OMEGAY(0:NDOMEG),
     *          OMEGAZ(0:NDOMEG)
C
C        Standard Woods-Saxon Parameter Set
C
      COMMON
     *       /NUCLEONIC_NUM/ IZ_ACT,IN_ACT
     *       /NUCLEONIC_UNI/ NUNITS,NUCAVR
     *       /NUCLEONIC_YES/ P_ONLY,N_ONLY
     *       /NUCLEONIC_PAR/ SELPAR
      COMMON
     *       /GAUSSINTG_HER/ NXHERM,NYHERM,NZHERM,IOPTGS
     *       /GAUSSINTG_EPS/ EPSHER
     *       /GAUSSINTG_ANG/ NTHPNT,NFIPNT
      COMMON
     *       /HFBASE_BASE_2/ BASEX2,BASEY2,BASEZ2
      COMMON
     *       /PRECISION_EPS/ EPSF_S,EPSG_S,APROAC
     *       /PRECISION_MSH/ MESHTH,ITERNS
      COMMON
     *       /WIGNERROT_ANG/ ALFAWG,BETAWG,GAMAWG
     *       /WIGNERROT_IFW/ IFWIGN
     *       /SIGNATURE_FIX/ ISIGNY,IAUTOM
      COMMON
     *       /NOSCILCUT_ENE/ ENECUT,FCHOM0
     *       /NOSCILCUT_NOS/ NOSCIL,NLIMIT,ISOTRO
      COMMON
     *       /PARAMISOS_NEU/ V0DEPN,R0CENN,A0DIFN,S0LSON,R0SORN,A0DISN,
     *                       X0DEPN,X0CENN,X0DIFN,X0LSON,X0SORN,X0DISN,
     *                       Y0DEPN,Y0CENN,Y0DIFN,Y0LSON,Y0SORN,Y0DISN
     *
     *       /PARAMISOS_PRO/ V0DEPP,R0CENP,A0DIFP,S0LSOP,R0SORP,A0DISP,
     *                       X0DEPP,X0CENP,X0DIFP,X0LSOP,X0SORP,X0DISP,
     *                       Y0DEPP,Y0CENP,Y0DIFP,Y0LSOP,Y0SORP,Y0DISP
      COMMON
     *       /DIRECTPAR_NEU/ VOCENN,ROCENN,AOCENN,XLAMBN,ROSORN,AOSORN
     *       /DIRECTPAR_PRO/ VOCENP,ROCENP,AOCENP,XLAMBP,ROSORP,AOSORP
      COMMON
     *       /YUKAWAPOT_DIF/ DIFYUK,V0SHRP,V0DIFF
     *       /YUKAWAPOT_MOD/ IF_YUK,MODCOU
      COMMON
     *       /NAMELI_NOSORB/ NOSORB
      COMMON
     *       /COUFACTOR_PRO/ COUFAC
      COMMON
     *       /PARAMS_R0PARM/ R0PARM
C
C=======================================================================
C         INPUT-OUTPUT          INPUT-OUTPUT           INPUT-OUTPUT
C=======================================================================
C
      COMMON
     *       /REVIEWING_PAR/ INDCAR,INDNIL,INDSPL,INDSPE,INDDEN,INDDEP,
     *                                                          INDSPI
     *       /REVIEWING_STY/ IOPARS,IODEFS,IOROTS
      COMMON
     *       /LABELLING_WAV/ KARWAV,MAXWAV,NILWAV,IWAVSP
     *       /LABELLING_CNT/ KARTLB,MAXXYZ,NILSLB
     *       /LABELLING_SPH/ LABSPH,LABSPE
     *       /LABELLING_ONN/ LBATES
      COMMON
     *       /ENERGYCUT_DSK/ INDENE ! Important for long calculations!
      COMMON
     *       /CONTROLIN_ENE/ EMINST,EMAXST,EMINWF,EMAXWF,SPHMAX,EMINCH,
     *                                                          EMAXCH
     *       /CONTROLIN_ARG/ XCUT_P,YCUT_P,ZCUT_P,ARGMIN,ARGMAX
     *       /CONTROLIN_MOD/ MODE_X,MODE_Y,MODE_Z
     *       /CONTROLIN_LIN/ NOFLIN
      COMMON
     *       /PLOSHAPES_IPL/ IPLOP1,IPLOP2,IPLOTH
     *       /PLOSHAPES_PHI/ PHIPL1,PHIPL2
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C         EXTRA FEATURES       EXTRA FEATURES       EXTRA FEATURES
C=======================================================================
C
      COMMON
     *       /HF_MEAN_FIELD/ KHFPOT
      COMMON
     *       /NUCLEONIC_DEN/ IFDENI,IFDENS,IF_XYZ
     *       /NUCLEONIC_RMX/ R_MAXI
      COMMON
     *       /DELTAFRCE_INT/ IFDELT,LIMLOW,LIMUPP
      COMMON
     *       /MULTIPOLE_LMU/ IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
      COMMON
     *       /SPHERICAL_WAV/ IFWAVE
C
C                           Pairing
C
      COMMON
     *       /PAIRIN_SWITCH/ IFPAIR,IFPROJ,IF_BCS,IF_LIP
      COMMON
     *       /PAIRIN_QPNEUT/ NNPPPS(1:NDKONF),NNPPNS(1:NDKONF),
     *                       NNNPPS(1:NDKONF),NNNPNS(1:NDKONF)
      COMMON
     *       /PAIRIN_QPPROT/ NPPPPS(1:NDKONF),NPPPNS(1:NDKONF),
     *                       NPNPPS(1:NDKONF),NPNPNS(1:NDKONF)
      COMMON
     *       /PAIRIN_STRENG/ GFACTN,GFACTP
     *       /PAIRIN_WINDOW/ LEVPUP,LEVPDW,LEVNUP,LEVNDW
     *       /PAIRIN_ITRATI/ ITRNEW
     *       /PAIRIN_ITINNO/ DLZERO,BISTEP,SYSLIM
      COMMON
     *       /PAIRIN_FORPRO/ IFMINV,IFLAMD
      COMMON
     *       /PAIRIN_AVRGDE/ WINDEN,ENSTEP,ISMOTH
      COMMON
     *       /EXTRAS_CHOOSD/ IDELSM,IDELTA
C
      COMMON
     *       /PAIRIN_ALLGAP/ DELTAN,DELTAP
      COMMON
     *       /EXTRAS_FERMIS/ EFERMN,EFERMP
     *       /EXTRAS_PSTRNG/ GPAIRN,GPAIRP
C
C                  Deformations and minimization
C
      COMMON
     *       /MINIMI_TYPMIN/ I_MODE
     *       /MINIMI_ABORTG/ IABORT
     *       /MINIMI_RANRAN/ I_RAND,NSTART,LDRAND,I_SEED,IRANDO
     *       /MINIMI_METHOD/ IMETRI,IMTALK
     *       /MINIMI_MINITE/ IDEFCN,ITECHI,IWRIMI
     *       /MINIMI_LOOPIN/ I_LOOP
     *       /MINIMI_TOLENE/ ENECRI
     *       /MINIMI_OUTPUT/ NFIPRI
      COMMON
     *       /MINIMI_MINIMI/ STEPMX,TOLFUN,TOLDLX,TOLGRD,
     *                       EPSILO,FRACTI,GRADLM,ITRMAX
      COMMON
     *       /MINIMI_RANDSR/ ARANDO(1:NRANDO)
      COMMON
     *       /HFBASE_DEFORM/ BETBAS(0:NDLAMB,-NDLAMB:NDLAMB)
      COMMON
     *       /DEFMIN_QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                       QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                       IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /REALALMUL_DEF/ IREALA
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /TETANDOKT_DEF/ IFTETR,IFOKTR
C
C         Cranking Control Params
C
      COMMON
     *       /CRANKINGX_NOF/ KRANKX,NOFOMX,ISPINX
     *       /CRANKINGX_OME/ OMEGX0,STEPOX,SPIN_X
      COMMON
     *       /CRANKINGY_NOF/ KRANKY,NOFOMY,ISPINY
     *       /CRANKINGY_OME/ OMEGY0,STEPOY,SPIN_Y
      COMMON
     *       /CRANKINGZ_NOF/ KRANKZ,NOFOMZ,ISPINZ
     *       /CRANKINGZ_OME/ OMEGZ0,STEPOZ,SPIN_Z
      COMMON
     *       /CRANKING3_ANG/ THEANG,PHIANG,KRANK3
      COMMON
     *       /CRANKI_OMEGAS/ OMEGAT(0:NDOMEG),OMEGA3(0:NDOMEG)
C
      COMMON
     *       /LBKARR_ALIGNS/ ALIGNJ(1:NDBASE),
     *                       ALIGNL(1:NDBASE),
     *                       ALIGNS(1:NDBASE)
C
C         History of the DISTAN function (iterations/failures)
C
      COMMON
     *       /DISTAN_HISDIS/ ICALLS(1:NDCASE),IFAILS(1:NDCASE)
     *       /DISTAN_HISITR/ HISITE(1:NDCASE)
C
C         Some filenames & other string contained information
C
      COMMON
     *       /MAINPR_FILENS/ FILE_P,FILE_N
      COMMON
     *       /CHOOSEFIL_OUT/ NAMEFI
C
C=======================================================================
C
C        This subroutine predefines all the parameter values used
C        by the WS_CODE.  The presence of this routine allows the
C        user  to simply eliminate most of the input lines in the
C        rather crowded standard input file.
C
C=======================================================================
C
      PINUMB=4.0*ATAN(1.0)
C
C      Defining the Nucleus and Selecting some Parameters
C
      NUNITS='NEW'
      NUCAVR='REALVAL'
      SELPAR='UNIVERSAL_PARAM'
      P_ONLY='YES'
      N_ONLY='YES'
C
      WRITE(FILE_N,'(256X)')
      WRITE(FILE_P,'(256X)')
C
      FILE_N='ws_n'
      FILE_P='ws_p'
C
      IZ_ACT=66
      IN_ACT=86
C
C      Precision  Conditions  for  the Gauss Integrations
C
      NXHERM=40
      NYHERM=40
      NZHERM=40
      IOPTGS=0
      EPSHER=1.E-14
C
      NTHPNT=32
      NFIPNT=32
C
      BASEX2=0.0
      BASEY2=0.0
      BASEZ2=0.0
C
C      Setting precision parameters of distance equation
C
      EPSF_S=1.0e-8
      EPSG_S=1.0e-8
      APROAC=0.0001
C
      MESHTH=30
      ITERNS=80
C
C      Setting signature-symmetry index (conserved => 1)
C
      ISIGNY=1
      IAUTOM=1
C
C      Setting  the Wigner-Rotation  control  parameters
C
      IFWIGN=0
      ALFAWG=0
      BETAWG=0
      GAMAWG=0
C
C      Oscillator's NOSCIL: hamiltonian matrix dimension
C
      FCHOM0=1.2
      ENECUT=800
C
      NLIMIT=450
      ISOTRO=0
      NOSCIL=14
C
C      Reading the Woods-Saxon <=> Dirac-type parameters
C
      V0DEPN=106.00
      R0CENN=1.0600
      A0DIFN=1.3600

      S0LSON=24.800
      R0SORN=0.8300
      A0DISN=0.4500

      X0DEPN=-0.480
      X0CENN=-.0030
      X0DIFN=0.1200

      X0LSON=-0.500
      X0SORN=0.0400
      X0DISN=1.0000

      Y0DEPN=-0.430
      Y0CENN=-.2000
      Y0DIFN=-0.850

      Y0LSON=-0.520
      Y0SORN=-.0400
      Y0DISN=0.7000
C
      V0DEPP=105.50
      R0CENP=0.9500
      A0DIFP=1.2700

      S0LSOP=24.000
      R0SORP=0.7100
      A0DISP=0.4000

      X0DEPP=-.4200
      X0CENP=0.8000
      X0DIFP=0.8000

      X0LSOP=-.8000
      X0SORP=0.8000
      X0DISP=0.8000

      Y0DEPP=-.7500
      Y0CENP=0.3500
      Y0DIFP=-.9000

      Y0LSOP=-.6000
      Y0SORP=-.2000
      Y0DISP=2.0000
C
      VOCENN=90.180
      ROCENN=1.0120
      AOCENN=1.1200

      XLAMBN=20.545
      ROSORN=0.8260
      AOSORN=0.5700
C
      VOCENP=82.920
      ROCENP=1.1090
      AOCENP=1.1280

      XLAMBP=18.653
      ROSORP=0.7410
      AOSORP=0.6140
C
      DIFYUK=0.7500
      V0SHRP=0     ! Proper value to be given after literature
      V0DIFF=0     ! Proper value to be given after literature
C
      IF_YUK=0
      MODCOU=1
C
      NOSORB=0
C
      COUFAC=1.0
C
      R0PARM=1.35
C
      KHFPOT=0
C
C=======================================================================
C         INPUT-OUTPUT        INPUT-OUTPUT         INPUT-OUTPUT
C=======================================================================
C
C      Choice of the review-type output
C
      INDCAR=0
      INDNIL=0
      INDSPL=0
      INDSPE=0
      INDDEN=0
      INDDEP=0
      INDSPI=0
C
      IOPARS=0
      IODEFS=1
      IOROTS=0
C
C      Choice of labels
C
      KARWAV=0
      MAXWAV=0
      NILWAV=0
      IWAVSP=0
C
      KARTLB=0
      MAXXYZ=0
      NILSLB=0
C
      LABSPH=0
      LABSPE=0
C
C      When fancy labels are required LBATES must be one
C              - otherwise zero, to save a lot of memory
C
      LBATES=1
C
      INDENE=455
C
C      Reading the printout control parameters
C
      EMINST=-60.0
      EMAXST=+40.0
      EMINWF=-60.0
      EMAXWF=+05.0
      SPHMAX=+60.0
      EMINCH=-60.0
      EMAXCH=+05.0
C
      XCUT_P=+0.4
      YCUT_P=+0.3
      ZCUT_P=+0.3
      ARGMIN=-2.0
      ARGMAX=+2.0
C
C      Reading the Woods-Saxon potential-plot parameters
C
      MODE_X=0
      MODE_Y=0
      MODE_Z=0
C
      NOFLIN=+55
C
C      The phi-values for plots of the nuclear surface
C
      IPLOP1=0
      IPLOP2=0
      IPLOTH=0
C
      PHIPL1=00.0
      PHIPL2=90.0
C
      PHIPL1=PINUMB/180.0*PHIPL1
      PHIPL2=PINUMB/180.0*PHIPL2
C
C      READ/WRITE unit
C
      NOUTPT=6
      IWRITE=0
      ISCREN=0
C
C=======================================================================
C     EXTRA FEATURES      EXTRA FEATURES      EXTRA FEATURES
C=======================================================================
C
      KHFPOT=0
C
      IFDENI=0
      IFDENS=0
      IF_XYZ=0
C
      R_MAXI=10.0
C
C      The delta-force directives  (option for new pairng)
C
      IFDELT=00
      LIMLOW=20
      LIMUPP=20
C
C      Special option:   Calculating the multipole moments
C
      IFMULT=1
      MAXMUL=4
      NOFLEV=15
      IINDIV=0
      LAMIND=2
      MIUIND=0
C
C      Reading the  Woods-Saxon wave-function calc. cntrl.
C
      IFWAVE=0
C
      IFPAIR=1
      IFPROJ=0
      IF_BCS=1
      IF_LIP=0
C
      DO I_KONF=1,NDKONF
         NNPPPS(I_KONF)=0
         NNPPNS(I_KONF)=0
         NNNPPS(I_KONF)=0
         NNNPNS(I_KONF)=0
      END DO
C
      DO I_KONF=1,NDKONF
         NPPPPS(I_KONF)=0
         NPPPNS(I_KONF)=0
         NPNPPS(I_KONF)=0
         NPNPNS(I_KONF)=0
      END DO
C
      GFACTN=1.0
      GFACTP=1.0
C
      LEVPUP=IZ_ACT/2
      LEVPDW=IZ_ACT/2
      LEVNUP=IN_ACT/2
      LEVNDW=IN_ACT/2
C
      ITRNEW=20
C
      DLZERO=1.0
      BISTEP=0.3
      SYSLIM=2.5
C
      IFMINV=0
      IFLAMD=1
C
      WINDEN=3.5
      ENSTEP=0.25
      ISMOTH=12
C
      IDELSM=2
      IDELTA=2
C
      DELTAN=1.0
      DELTAP=1.0
C
      EFERMN=-8.0
      EFERMP=-8.0
C
      GPAIRN=0.2
      GPAIRP=0.2
C
C=======================================================================
C                  DEFORMATIONS AND MINIMIZATION
C=======================================================================
C
      I_MODE=2
C
      IABORT=0
C
      I_RAND=0
      NSTART=0
      LDRAND=0
      I_SEED=0
      IRANDO=0
C
      IMETRI=1
      IMTALK=1
C
      IDEFCN=0
      ITECHI=100
      IWRIMI=0
C
      I_LOOP=0
C
      ENECRI=0.001
C
      NFIPRI=6
C
      STEPMX=0.01
      TOLFUN=1.E-7
      TOLDLX=1.E-7
      TOLGRD=1.E-7
      EPSILO=3.E-8
      FRACTI=0.01
      GRADLM=0.5
      ITRMAX=500
C
      DO I=1,NRANDO
         ARANDO(I)=0.0
      END DO
C
      DO LAMBDA=0,NDLAMB
         DO MIU=-NDLAMB,NDLAMB
C
            BETBAS(LAMBDA,MIU)=CMPLX(0.0,0.0)
C
            ALSTRT(LAMBDA,MIU)=CMPLX(0.000,0.0)
            ALSTEP(LAMBDA,MIU)=CMPLX(0.001,0.0)
            ALMINI(LAMBDA,MIU)=CMPLX(0.000,0.0)
            ALMAXI(LAMBDA,MIU)=CMPLX(0.000,0.0)
C
            I_STEP(LAMBDA,MIU)=0
C
         END DO
      END DO
C
      DO LAMBDA=0,NDMULT
         DO MIU=-NDMULT,NDMULT
C
            QASKED(LAMBDA,MIU)=0.0
            STIFFQ(LAMBDA,MIU)=0.5
            IFLAGQ(LAMBDA,MIU)=0
C
         END DO
      END DO
C
      IREALA=1
C
      IFTETR=0
      IFOKTR=0
C
C     Cranking Control Parameters
C
      KRANKX=0
      NOFOMX=1
      ISPINX=0
C
      OMEGX0= 0.0
      STEPOX= 0.1
      SPIN_X=90.0
C
      DO I=1,NDOMEG
         OMEGAX(I)=OMEGX0+(I-1)*STEPOX
      END DO
C
      KRANKY=0
      NOFOMY=1
      ISPINY=0
C
      OMEGY0= 0.0
      STEPOY= 0.1
      SPIN_Y=90.0
C
      DO I=1,NDOMEG
         OMEGAY(I)=OMEGY0+(I-1)*STEPOY
      END DO
C
      KRANKZ=0
      NOFOMZ=1
      ISPINZ=0
C
      OMEGZ0= 0.0
      STEPOZ= 0.1
      SPIN_Z=90.0
C
      DO I=1,NDOMEG
         OMEGAZ(I)=OMEGZ0+(I-1)*STEPOZ
      END DO
C
      THEANG=0.0
      PHIANG=0.0
      KRANK3=0
C
      DO I=1,NDOMEG
         OMEGAT(I)=0.0
         OMEGA3(I)=0.0
      END DO
C
      NOFOME=0
C
      DO I=1,NDBASE
         ALIGNJ(I)=0.0
         ALIGNL(I)=0.0
         ALIGNS(I)=0.0
      END DO
C
C      Zeroing the DISTANCE function performance control paramets
C
      DO I=1,NDCASE
         ICALLS(I)=0
         IFAILS(I)=0
         HISITE(I)=0
      END DO
C
C      Selecting the   n a m e  generated by the program if
C      NAMEFI=1. In such a case the filename of the results
C      will automatically contain the information about the
C      nucleus  and the first values  of the quadrupole and
C      hexadecapole deformations
C
C     KEYWOR = 'CHOOSEFIL-OUT'
C
      NAMEFI=0 ! => KEEP THE ABOVE NAMES
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_NCONST(NUNITS,NUCAVR)
      CHARACTER
     *          NUNITS*3,NUCAVR*7,STRING*80
      COMMON
     *       /NCONST_CONSTS/ HBAR_C,XMASSP,XMASSN,HCOVE2,E2OVHC
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C         Subroutine  NCONST  defines  natural constants according
C         to two schemes:
C
C         a. An 'OLD' way, that existed  in the old w-s codes, and
C         b. According to 'Review of Particle Physics' sheets from
C            Phys. Rev. D54 (1996) 1
C
C=======================================================================
C
      IF (NUNITS.EQ.'OLD') THEN
C
          HBAR_C=197.32891
          HCOVE2=137.03602
          E2OVHC=1./HCOVE2
C
          IF (NUCAVR.EQ.'REALVAL') THEN
              XMASSP=938.27231
              XMASSN=938.90590
          END IF
C
          IF (NUCAVR.EQ.'AVERAGE') THEN
              XMASSN=0.5*(938.27231+938.90590)
              XMASSP=0.5*(938.27231+938.90590)
          END IF
C
      END IF
C
      IF (NUNITS.EQ.'NEW') THEN
C
          HBAR_C=197.327053   ! Units: MeV*fm;   ERROR: (+/-)0.000059
          XMASSP=938.27231    ! Units: MeV/c**2; ERROR: (+/-)0.00028
          XMASSN=939.56563    ! Units: MeV/c**2; ERROR: (+/-)0.00028
          HCOVE2=137.0359895  ! Dimensioneless;  ERROR: (+/-)0.0000061
C
          E2OVHC=1.00/HCOVE2
C
          IF (NUCAVR.EQ.'AVERAGE') THEN
              XMASSN=0.5*(938.27231 + 939.56563)
              XMASSP=0.5*(938.27231 + 939.56563)
          END IF
C
      END IF
C
C=======================================================================
C     #) Definition of 'HCOVE2' is: e**2/(4pi*epsilon0*hbarc)
C=======================================================================
C
      IF (.NOT.(NUNITS.EQ.'NEW'.OR.NUNITS.EQ.'OLD')) THEN
          STOP 'Natural constant are undefined, check variable NUNITS'
      END IF
C
      IF (.NOT.(NUCAVR.EQ.'REALVAL'.OR.NUCAVR.EQ.'AVERAGE')) THEN
          STOP 'Nucleon masses must be either NATURAL or AVERAGES'
      END IF
C
C=======================================================================
C
      IF (IWRITE.GE.1) THEN
C
          IF (NUNITS.EQ.'NEW') THEN
              WRITE(STRING(1:38),
     *                 '(''#  New set of natural constants used; '')')
          END IF
C
          IF (NUNITS.EQ.'OLD') THEN
              WRITE(STRING(1:38),
     *                 '(''#  Old set of natural constants used; '')')
          END IF
C
C=======================================================================
C
          IF (NUCAVR.EQ.'REALVAL') THEN
              WRITE(STRING(39:80),
     *               '(''R E A L values of the nucleonic masses   #'')')
          END IF
C
          IF (NUCAVR.EQ.'AVERAGE') THEN
              WRITE(STRING(39:80),
     *               '(''Average values of the nucleonic masses   #'')')
          END IF
C
C=======================================================================
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,A80,/,
     *                         ''#'',78X,''#'',/,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
